package com.sun.imageio.plugins.common;

import java.io.IOException;
import javax.imageio.stream.ImageOutputStream;

public class BitFile
{
    ImageOutputStream output;
    byte[] buffer;
    int index;
    int bitsLeft;
    boolean blocks;
    
    public BitFile(ImageOutputStream output, boolean blocks) {
        this.blocks = false;
        this.output = output;
        this.blocks = blocks;
        this.buffer = new byte[256];
        this.index = 0;
        this.bitsLeft = 8;
    }
    
    public void flush() throws IOException {
        int n = this.index + ((this.bitsLeft == 8) ? 0 : 1);
        if (n > 0) {
            if (this.blocks) {
                this.output.write(n);
            }
            this.output.write(this.buffer, 0, n);
            this.buffer[0] = 0;
            this.index = 0;
            this.bitsLeft = 8;
        }
    }
    
    public void writeBits(int n, int i) throws IOException {
        int n2 = 0;
        int n3 = 255;
        do {
            if ((this.index == 254 && this.bitsLeft == 0) || this.index > 254) {
                if (this.blocks) {
                    this.output.write(n3);
                }
                this.output.write(this.buffer, 0, n3);
                this.buffer[0] = 0;
                this.index = 0;
                this.bitsLeft = 8;
            }
            if (i <= this.bitsLeft) {
                if (this.blocks) {
                    byte[] buffer4 = this.buffer;
                    int index4 = this.index;
                    buffer4[index4] |= (n & (1 << i) - 1) << 8 - this.bitsLeft;
                    n2 += i;
                    this.bitsLeft -= i;
                    i = 0;
                }
                else {
                    byte[] buffer3 = this.buffer;
                    int index3 = this.index;
                    buffer3[index3] |= (n & (1 << i) - 1) << this.bitsLeft - i;
                    n2 += i;
                    this.bitsLeft -= i;
                    i = 0;
                }
            }
            else if (this.blocks) {
                byte[] buffer2 = this.buffer;
                int index2 = this.index;
                buffer2[index2] |= (n & (1 << this.bitsLeft) - 1) << 8 - this.bitsLeft;
                n2 += this.bitsLeft;
                n >>= this.bitsLeft;
                i -= this.bitsLeft;
                this.buffer[++this.index] = 0;
                this.bitsLeft = 8;
            }
            else {
                int n4 = n >>> i - this.bitsLeft & (1 << this.bitsLeft) - 1;
                byte[] buffer = this.buffer;
                int index = this.index;
                buffer[index] |= n4;
                i -= this.bitsLeft;
                n2 += this.bitsLeft;
                this.buffer[++this.index] = 0;
                this.bitsLeft = 8;
            }
        } while (i != 0);
    }
}
